import { Disposable, FetchPolicy, OperationDescriptor, IEnvironment, Snapshot, RenderPolicy, GraphQLResponse } from 'relay-runtime';
export declare type Fetcher = {
    fetch: (environment: IEnvironment, operation: OperationDescriptor, fetchPolicy: FetchPolicy | null | undefined, onComplete: (_e: Error | null, doUpdate: boolean) => void, onNext: (operation: OperationDescriptor, snapshot: Snapshot, doUpdate: boolean) => void, onResponse?: (response: GraphQLResponse | null) => void, renderPolicy?: RenderPolicy) => Disposable;
    getData: () => {
        isLoading: boolean;
        error?: Error | null;
    };
    dispose: () => void;
    checkAndSuspense: (suspense: boolean, useLazy?: boolean) => Promise<any> | Error | null;
};
export declare function fetchResolver({ doRetain, disposeTemporary, }: {
    doRetain?: boolean;
    disposeTemporary?: () => void;
}): Fetcher;
