import { GraphQLTaggedNode } from 'relay-runtime';
import { KeyType, KeyReturnType, $Call, ArrayKeyType, ArrayKeyReturnType } from './RelayHooksTypes';
export declare function useFragment<TKey extends KeyType>(fragmentNode: GraphQLTaggedNode, fragmentRef: TKey): $Call<KeyReturnType<TKey>>;
export declare function useFragment<TKey extends KeyType>(fragmentNode: GraphQLTaggedNode, fragmentRef: TKey | null): $Call<KeyReturnType<TKey>> | null;
export declare function useFragment<TKey extends ArrayKeyType>(fragmentNode: GraphQLTaggedNode, fragmentRef: TKey): ReadonlyArray<$Call<ArrayKeyReturnType<TKey>>>;
export declare function useSuspenseFragment<TKey extends KeyType>(fragmentNode: GraphQLTaggedNode, fragmentRef: TKey): $Call<KeyReturnType<TKey>>;
export declare function useSuspenseFragment<TKey extends KeyType>(fragmentNode: GraphQLTaggedNode, fragmentRef: TKey | null): $Call<KeyReturnType<TKey>> | null;
export declare function useSuspenseFragment<TKey extends ArrayKeyType>(fragmentNode: GraphQLTaggedNode, fragmentRef: TKey): ReadonlyArray<$Call<ArrayKeyReturnType<TKey>>>;
export declare function useFragmentSubscription<TKey extends KeyType>(fragmentNode: GraphQLTaggedNode, fragmentRef: TKey, callback: (data: $Call<KeyReturnType<TKey>>) => void): void;
export declare function useFragmentSubscription<TKey extends KeyType>(fragmentNode: GraphQLTaggedNode, fragmentRef: TKey | null, callback: (data: $Call<KeyReturnType<TKey>> | null) => void): void;
export declare function useFragmentSubscription<TKey extends ArrayKeyType>(fragmentNode: GraphQLTaggedNode, fragmentRef: TKey, callback: (data: ReadonlyArray<$Call<ArrayKeyReturnType<TKey>>>) => void): void;
